<?php

/**
 * Carerix Wordpress Plugin
 *
 * @category settings
 * @author Bogdan Ivanov
 * @copyright Copyright (c) 2013 Carerix.com (http://www.carerix.com)
 * @link http://www.carerix.com
 * @since Aug 29, 2013 12:55:30 PM
 * @version $Rev$
 */


/**
 * Cron class
 * Used to define cron objects
 */
abstract class Entity_Cron {
	
    protected $page = 0;


    /**
	 *
	 * @var WP_Interfacer 
	 */
	protected $interfacer = null;
	
	/**
	 *
	 * @var string 
	 */
	protected $url = '';
	
	/**
	 *
	 * @var array 
	 */
	protected $sourceData = array();
	
	/**
	 *
	 * @var boolean 
	 */
	protected $usesUrl = true;
	
	protected $afterFinishData = array();
	
	/**
	 * 
	 * @param array $sourceData
	 */
	public function __construct($sourceData) {
		$this->interfacer = WP_Interfacer::getInstance();
		$this->sourceData = $sourceData;
  	}
	
	abstract function getUrl();
	abstract function process($data);
	
    
    public function setPage($page) {
        $this->page = $page;
    }
    
    public function getPage()
    {
        return $this->page;
    }
	/**
	 * 
	 * @return SimpleXML
	 */
	private function retrieveData()
	{
		if(!$this->usesUrl) return;
		$page = $this->page;
        $start = (int)$page * WP_Constants::NR_OF_ITEMS;
        $url = $this->getUrl();
        $glue = '?';
        $token = Environment_Settings::getAppToken();
        if(stripos($url, '?') !== FALSE) $glue = '&';
        $newUrl = $url . $glue . 'start=' . $start.'&count='.WP_Constants::NR_OF_ITEMS.'&token='.$token;
        $ch = curl_init( $newUrl );
        curl_setopt($ch, CURLOPT_HEADER, false);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        $feed_string = curl_exec($ch);
        $response = curl_getinfo($ch, CURLINFO_HTTP_CODE);
        curl_close($ch);
        if($response == 200)
        {
            $feedData = simplexml_load_string($feed_string);
            return $feedData;
        } else
        {
            throw new Exception('Error: the synchronization process failed. Please try again. If the problem persists please contact your Carerix administrator. '
                    . "<br> Got response code $response while accessing $newUrl");
        }
	}
	
	/**
	 * 
	 * @return boolean
	 */
	private function urlIsValid()
	{
        return;
		$service_handle = fopen($this->getUrl(), 'r');
		if($service_handle === false) {
            return false;
        }
		return true;
	}
	
	/**
	 * sends the retrieved data to the process method of the cron mechanism
     * retrieves number of items processed
	 */
	public function run()
	{
		$data = $this->retrieveData();
		return $this->process($data);
	}
	
	public function getAfterFinish()
	{
		return $this->afterFinishData;
	}
}