<?php

/**
 * Carerix Wordpress Plugin
 *
 * @category settings
 * @author Bogdan Ivanov
 * @copyright Copyright (c) 2013 Carerix.com (http://www.carerix.com)
 * @link http://www.carerix.com
 * @since Aug 29, 2013 1:08:16 PM
 * @version $Rev$
 */


/**
 * Job class
 * Used to ....
 */
class Entity_Cron_Newsletter extends Entity_Cron {
	
	public function getUrl() {
		$newslettersUrl = Environment_Installation::get_newsletters_feed();
		if(@$this->sourceData['settings']['feed'])
		{
			$newslettersUrl .= '?' . $this->sourceData['settings']['feed'];
		}
		return $newslettersUrl;
	}

	public function process($data) {
        Utils_Cache::cleanEnvironment();
		$items = $data->channel->item;

		/**
		 * foreach article, write it as a post, 
		 * and set as category the newsletter and edition
		 */
		$newslettersTable = $this->getArrayOfItems($items);
		foreach($newslettersTable as $newsletter)
		{
			foreach($newsletter['editions'] as $edition)
			{
				foreach($edition['articles'] as &$article)
				{
					$article['newsletter_id'] = $newsletter['newsletter_id'];
					$article['newsletter_name'] = $newsletter['newsletter_name'];
					$article['edition_id'] = $edition['edition_id'];
					$article['edition_name'] = $edition['edition_title'];
					$article = new Entity_Writer_Article($article);
					$id = $article->write();
					
					$this->interfacer->entity_set_property($id, 'source', $this->sourceData['id']);
                    $this->interfacer->entity_set_property( $id, 
													'source', 
													$this->sourceData['id']);
					
					if($this->interfacer->wpml_is_active())
					{
						$defaultLanguage = $this->interfacer->language_major_current();
						$this->interfacer->wpml_register_translation($id, $id, 'post_post', $defaultLanguage);
					}
				}
			}
		}
		 
	}
	
	/**
	 * creates a table of newsletters, editions and articles
	 * @param type $data
	 * @return array
	 */
	private function getArrayOfItems($data)
	{
		$items = array();
		
		$collectors = array(
			'guid', 'pubDate', 'name', 'reviewInfo'
		);
		
		
		foreach($data as $item)
		{

			$newItem = array();
			$newItem['newsletter_id'] = (string)$item->id;
			$newItem['newsletter_name'] = (string)$item->title;
			$newItem['editions'] = array();
			
			foreach($item->editions->edition as $editionNode)
			{
				$edition = array();
				$edition['edition_id'] = (string)$editionNode->id;
				$edition['edition_title'] = (string)$editionNode->title;
				$edition['edition_subject'] = (string)$editionNode->subject;
				$edition['articles'] = array();
				
				foreach($editionNode->articles->article as $articleNode)
				{
					$article = array();
					$article['id'] = (string)$articleNode->id;
					$article['content'] = (string)$articleNode->content;
					$article['subtitle'] = (string)$articleNode->subtitle;
					$article['title'] = (string)$articleNode->title;
					$article['creationDate'] = (string)$articleNode->creationDate;
					array_push($edition['articles'], $article);
				}
				
				array_push($newItem['editions'], $edition);
			}
			
			foreach($collectors as $collector)
			{
				if(isset($item->$collector) && strlen(trim((string)$item->$collector)) > 0)
				{
					$newItem[$collector] = (string)$item->$collector;
				}
			}
			
			if(!empty($newItem)) array_push ($items, $newItem);
		}
		
		return $items;
	}
}


