<?php

class Utils_CronCleaner {
    /**
     * @var WP_Interfacer;
     */
    private $interfacer  = null;
    
    private $source_id = 0;
    
    public function __construct($source_id) {
        $this->interfacer = WP_Interfacer::getInstance();
        $this->source_id = $source_id;
    }
    
    public function clean() {
        $postMetaTable = $this->interfacer->db_get_postmeta_name();
        $query = "DELETE FROM `$postMetaTable` WHERE `meta_key` = 'source_cron' and `meta_value` = {$this->source_id}";
        $this->interfacer->db_query($query);
    }
    
    public function run($type = false) {
        if($type === false || !$this->source_id) return;
        
        $postMetaTable = $this->interfacer->db_get_postmeta_name();
        
        if($this->interfacer->wpml_is_active()) {
            
            $languages = $this->interfacer->get_wpml_active_languages();
            $languages = array_keys($languages);
            
            foreach($languages as $language) {
                $language = trim(strtolower($language));
                $query = "
                SELECT * FROM `$postMetaTable`
                    WHERE `meta_key` = 'source'
                    AND `meta_value` = {$this->source_id}
                    AND `post_id` IN
                (SELECT post_id 
                      FROM `$postMetaTable` 
                      WHERE 
                        `meta_key` LIKE '%_carerix_{$type}_{$language}' 
                      AND `post_id` NOT IN 
                        (SELECT post_id FROM `$postMetaTable` 
                            WHERE 
                                `meta_key`   = 'source_cron'
                                AND
                                `meta_value` = {$this->source_id}))";
                
                $checkBroughtPublicationsSql = "
                SELECT post_id FROM `{$postMetaTable}`
                WHERE `meta_key` = 'source_cron'
                AND `meta_value` = {$this->source_id}
            ";
                
            $currentBatch = $this->interfacer->db_get_custom($checkBroughtPublicationsSql);
            if(count($currentBatch) <= 0 ) return false;
                $results = $this->interfacer->db_get_custom($query);
                foreach($results as $result) {
                    $this->interfacer->entity_delete($result['post_id']);
                    
                    do_action('cxwordpress_post_deleted', $result['post_id']);
                } 
            }
        } else {
            $query = "
            SELECT * FROM `{$postMetaTable}`
                WHERE `meta_key` = 'source'
                AND `meta_value` = {$this->source_id}
                AND `post_id` IN
            (SELECT post_id 
                  FROM `$postMetaTable` 
                  WHERE 
                    `meta_key` LIKE '%_carerix_{$type}' 
                  AND `post_id` NOT IN 
                    (SELECT post_id FROM `{$postMetaTable}` 
                        WHERE 
                            `meta_key`   = 'source_cron'
                            AND
                            `meta_value` = {$this->source_id}))";
            
            $checkBroughtPublicationsSql = "
                SELECT post_id FROM `{$postMetaTable}`
                WHERE `meta_key` = 'source_cron'
                AND `meta_value` = {$this->source_id}
            ";

            if ($type !== 'candidate') {
                $currentBatch = $this->interfacer->db_get_custom($checkBroughtPublicationsSql);
                if(count($currentBatch) <= 0 ) return false;
            }

            $results = $this->interfacer->db_get_custom($query);
            foreach($results as $result) {
                $this->interfacer->entity_delete($result['post_id']);
                
                do_action('cxwordpress_post_deleted', $result['post_id']);
            }
        }
        

    }
    
}