<?php

/**
 * Carerix Wordpress Plugin
 *
 * @category template manager
 * @author Bogdan Ivanov
 * @copyright Copyright (c) 2013 Carerix.com (http://www.carerix.com)
 * @link http://www.carerix.com
 * @since Jul 25, 2013 1:56:25 PM
 * @version $Rev$
 */

/**
 * Template class
 * Used to ....
 */
class Utils_Template {
	
	private $templatePath = null;
	private $data = array();
	
	public function __construct($template)
	{
		$templatepath = CARERIX_TEMPLATES_DIR . DIRECTORY_SEPARATOR .  
						implode(DIRECTORY_SEPARATOR, 
							array_filter(explode('/', $template))) . '.php';
		
		if( ! file_exists($templatepath) )
		{
			throw new DomainException('Invalid template provided');
		}
		$this->templatePath = $templatepath;
		return $this;
	}
	
	public function with($data = array())
	{
		$this->data = $data;
		return $this;
	}

	/**
	 * Outputs to screen or returns back in a variable
	 *
	 * @param bool $return  True for returning as a variable
	 *
	 * @return false|string
	 */
	public function display($return = false)
	{
        if($return) ob_start ();
		extract($this->data);
		require $this->templatePath;
        if($return)
        {
            $out = ob_get_contents();
            ob_clean();
            return $out;
        }
	}
}